# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CatalogItemUpfrontPriceResponseResourcePriceDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource_upfront_price_id': 'str',
        'resource_name': 'str',
        'resource_type': 'str',
        'daily_total_price': 'float',
        'daily_compute_price': 'float',
        'daily_storage_price': 'float',
        'daily_network_price': 'float',
        'daily_additional_price': 'float',
        'unit': 'CatalogItemResourceUpfrontPriceResponseUnit',
        'status_details': 'str',
        'status': 'str'
    }

    attribute_map = {
        'resource_upfront_price_id': 'resourceUpfrontPriceId',
        'resource_name': 'resourceName',
        'resource_type': 'resourceType',
        'daily_total_price': 'dailyTotalPrice',
        'daily_compute_price': 'dailyComputePrice',
        'daily_storage_price': 'dailyStoragePrice',
        'daily_network_price': 'dailyNetworkPrice',
        'daily_additional_price': 'dailyAdditionalPrice',
        'unit': 'unit',
        'status_details': 'statusDetails',
        'status': 'status'
    }

    def __init__(self, resource_upfront_price_id=None, resource_name=None, resource_type=None, daily_total_price=None, daily_compute_price=None, daily_storage_price=None, daily_network_price=None, daily_additional_price=None, unit=None, status_details=None, status=None):  # noqa: E501
        """CatalogItemUpfrontPriceResponseResourcePriceDetails - a model defined in Swagger"""  # noqa: E501
        self._resource_upfront_price_id = None
        self._resource_name = None
        self._resource_type = None
        self._daily_total_price = None
        self._daily_compute_price = None
        self._daily_storage_price = None
        self._daily_network_price = None
        self._daily_additional_price = None
        self._unit = None
        self._status_details = None
        self._status = None
        self.discriminator = None
        if resource_upfront_price_id is not None:
            self.resource_upfront_price_id = resource_upfront_price_id
        if resource_name is not None:
            self.resource_name = resource_name
        if resource_type is not None:
            self.resource_type = resource_type
        if daily_total_price is not None:
            self.daily_total_price = daily_total_price
        if daily_compute_price is not None:
            self.daily_compute_price = daily_compute_price
        if daily_storage_price is not None:
            self.daily_storage_price = daily_storage_price
        if daily_network_price is not None:
            self.daily_network_price = daily_network_price
        if daily_additional_price is not None:
            self.daily_additional_price = daily_additional_price
        if unit is not None:
            self.unit = unit
        if status_details is not None:
            self.status_details = status_details
        if status is not None:
            self.status = status

    @property
    def resource_upfront_price_id(self):
        """Gets the resource_upfront_price_id of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Id  # noqa: E501

        :return: The resource_upfront_price_id of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: str
        """
        return self._resource_upfront_price_id

    @resource_upfront_price_id.setter
    def resource_upfront_price_id(self, resource_upfront_price_id):
        """Sets the resource_upfront_price_id of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Id  # noqa: E501

        :param resource_upfront_price_id: The resource_upfront_price_id of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: str
        """

        self._resource_upfront_price_id = resource_upfront_price_id

    @property
    def resource_name(self):
        """Gets the resource_name of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501


        :return: The resource_name of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: str
        """
        return self._resource_name

    @resource_name.setter
    def resource_name(self, resource_name):
        """Sets the resource_name of this CatalogItemUpfrontPriceResponseResourcePriceDetails.


        :param resource_name: The resource_name of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: str
        """

        self._resource_name = resource_name

    @property
    def resource_type(self):
        """Gets the resource_type of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501


        :return: The resource_type of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this CatalogItemUpfrontPriceResponseResourcePriceDetails.


        :param resource_type: The resource_type of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def daily_total_price(self):
        """Gets the daily_total_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Total Price of the catalog resource.  # noqa: E501

        :return: The daily_total_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: float
        """
        return self._daily_total_price

    @daily_total_price.setter
    def daily_total_price(self, daily_total_price):
        """Sets the daily_total_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Total Price of the catalog resource.  # noqa: E501

        :param daily_total_price: The daily_total_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: float
        """

        self._daily_total_price = daily_total_price

    @property
    def daily_compute_price(self):
        """Gets the daily_compute_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Compute Price of the catalog resource.  # noqa: E501

        :return: The daily_compute_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: float
        """
        return self._daily_compute_price

    @daily_compute_price.setter
    def daily_compute_price(self, daily_compute_price):
        """Sets the daily_compute_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Compute Price of the catalog resource.  # noqa: E501

        :param daily_compute_price: The daily_compute_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: float
        """

        self._daily_compute_price = daily_compute_price

    @property
    def daily_storage_price(self):
        """Gets the daily_storage_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Storage Price of the catalog resource.  # noqa: E501

        :return: The daily_storage_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: float
        """
        return self._daily_storage_price

    @daily_storage_price.setter
    def daily_storage_price(self, daily_storage_price):
        """Sets the daily_storage_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Storage Price of the catalog resource.  # noqa: E501

        :param daily_storage_price: The daily_storage_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: float
        """

        self._daily_storage_price = daily_storage_price

    @property
    def daily_network_price(self):
        """Gets the daily_network_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Network Price of the catalog resource.  # noqa: E501

        :return: The daily_network_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: float
        """
        return self._daily_network_price

    @daily_network_price.setter
    def daily_network_price(self, daily_network_price):
        """Sets the daily_network_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Network Price of the catalog resource.  # noqa: E501

        :param daily_network_price: The daily_network_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: float
        """

        self._daily_network_price = daily_network_price

    @property
    def daily_additional_price(self):
        """Gets the daily_additional_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Additional Price incurred for the catalog.  # noqa: E501

        :return: The daily_additional_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: float
        """
        return self._daily_additional_price

    @daily_additional_price.setter
    def daily_additional_price(self, daily_additional_price):
        """Sets the daily_additional_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Additional Price incurred for the catalog.  # noqa: E501

        :param daily_additional_price: The daily_additional_price of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: float
        """

        self._daily_additional_price = daily_additional_price

    @property
    def unit(self):
        """Gets the unit of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501


        :return: The unit of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: CatalogItemResourceUpfrontPriceResponseUnit
        """
        return self._unit

    @unit.setter
    def unit(self, unit):
        """Sets the unit of this CatalogItemUpfrontPriceResponseResourcePriceDetails.


        :param unit: The unit of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: CatalogItemResourceUpfrontPriceResponseUnit
        """

        self._unit = unit

    @property
    def status_details(self):
        """Gets the status_details of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Upfront price status detail.  # noqa: E501

        :return: The status_details of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: str
        """
        return self._status_details

    @status_details.setter
    def status_details(self, status_details):
        """Sets the status_details of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Upfront price status detail.  # noqa: E501

        :param status_details: The status_details of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: str
        """

        self._status_details = status_details

    @property
    def status(self):
        """Gets the status of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501

        Upfront price sync status  # noqa: E501

        :return: The status of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CatalogItemUpfrontPriceResponseResourcePriceDetails.

        Upfront price sync status  # noqa: E501

        :param status: The status of this CatalogItemUpfrontPriceResponseResourcePriceDetails.  # noqa: E501
        :type: str
        """
        allowed_values = ["SUCCESS", "ERROR", "DATA_NOT_AVAILABLE", "CURRENCY_NOT_SET"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CatalogItemUpfrontPriceResponseResourcePriceDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CatalogItemUpfrontPriceResponseResourcePriceDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
